--- WARNING: THIS IS AN AUTO-GENERATED FILE, DO NOT EDIT. PLEASE MODIFY THE ORIGINAL SOURCE IN THE 'https://github.com/istio/istio' REPO source_repo: https://github.com/istio/istio title: istioctl description: Istio control interface. generator: pkg-collateral-docs number_of_entries: 75 max_toc_level: 2 remove_toc_prefix: 'istioctl ' ---

Istio configuration command line utility for service operators to debug and diagnose their Istio mesh.

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

## istioctl analyze

Analyze Istio configuration and print validation messages

    istioctl analyze <file>... [flags]

Flags | Shorthand | Description
--- | --- | ---
`--all-namespaces` |  | Analyze all namespaces
`--color` |  | Default true. Disable with '=false' or set $TERM to dumb
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--discovery` | `-d` | 'true' to enable service discovery, 'false' to disable it. Defaults to true if --use-kube is set, false otherwise. Analyzers requiring resources made available by enabling service discovery will be skipped.
`--failure-threshold <Level>` |  | The severity level of analysis at which to set a non-zero exit code. Valid values: [Info Warn Error] (default `Warn`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--list-analyzers` | `-L` | List the analyzers available to run. Suppresses normal execution.

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--meshConfigFile <string>` |  | Overrides the mesh config values to use for analysis. (default ``)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of [log json yaml] (default `log`)
`--output-threshold <Level>` |  | The severity level of analysis at which to display messages. Valid values: [Info Warn Error] (default `Info`)
`--use-kube` | `-k` | Use live Kubernetes cluster for analysis
`--verbose` | `-v` | Enable verbose output

### Examples

    # Analyze yaml files
    istioctl analyze a.yaml b.yaml

    # Analyze the current live cluster
    istioctl analyze -k

    # Analyze the current live cluster, simulating the effect of applying additional yaml files
    istioctl analyze -k a.yaml b.yaml

    # Analyze yaml files, overriding service discovery to enabled
    istioctl analyze -d true a.yaml b.yaml services.yaml

    # Analyze the current live cluster, overriding service discovery to disabled
    istioctl analyze -k -d false

    # List available analyzers
    istioctl analyze -L

## istioctl authn

A group of commands used to interact with Istio authentication policies. tls-check

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    # Check whether TLS setting are matching between authentication policy and destination rules:
    istioctl authn tls-check

## istioctl authn tls-check

Check what authentication policies and destination rules pilot uses to config a proxy instance, and check if TLS settings are compatible between them.

    istioctl authn tls-check <pod-name[.namespace]> [<service>] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    # Check settings for pod "foo-656bd7df7c-5zp4s" in namespace default:
    istioctl authn tls-check foo-656bd7df7c-5zp4s.default

    # Check settings for pod "foo-656bd7df7c-5zp4s" in namespace default, filtered on destination
    service "bar" :
    istioctl authn tls-check foo-656bd7df7c-5zp4s.default bar

## istioctl authz

(authz is experimental. Use `istioctl experimental authz`)

    istioctl authz [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

## istioctl convert-ingress

Converts Ingresses into VirtualService configuration on a best effort basis. The output should be considered a starting point for your Istio configuration and probably require some minor modification. Warnings will be generated where configs cannot be converted perfectly. The input must be a Kubernetes Ingress. The conversion of v1alpha1 Istio rules has been removed from istioctl.

    istioctl convert-ingress [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--filenames <stringSlice>` | `-f` | Input filenames (default `[]`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output filename (default `-`)

### Examples

    istioctl convert-ingress -f samples/bookinfo/platform/kube/bookinfo-ingress.yaml

## istioctl dashboard

Access to Istio web UIs

    istioctl dashboard [flags]

    istioctl dash [flags]
    istioctl d [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

## istioctl dashboard controlz

Open the ControlZ web UI for a pod in the Istio control plane

    istioctl dashboard controlz <pod-name[.namespace]> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--ctrlz_port <int>` |  | ControlZ port (default `9876`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--selector <string>` | `-l` | label selector (default ``)

### Examples

    istioctl dashboard controlz pilot-123-456.istio-system

## istioctl dashboard envoy

Open the Envoy admin dashboard for a sidecar

    istioctl dashboard envoy <pod-name[.namespace]> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--selector <string>` | `-l` | label selector (default ``)

### Examples

    istioctl dashboard envoy productpage-123-456.default

## istioctl dashboard grafana

Open Istio's Grafana dashboard

    istioctl dashboard grafana [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    istioctl dashboard grafana

## istioctl dashboard jaeger

Open Istio's Jaeger dashboard

    istioctl dashboard jaeger [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    istioctl dashboard jaeger

## istioctl dashboard kiali

Open Istio's Kiali dashboard

    istioctl dashboard kiali [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    istioctl dashboard kiali

## istioctl dashboard prometheus

Open Istio's Prometheus dashboard

    istioctl dashboard prometheus [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    istioctl dashboard prometheus

## istioctl dashboard zipkin

Open Istio's Zipkin dashboard

    istioctl dashboard zipkin [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    istioctl dashboard zipkin

## istioctl deregister

De-registers a service instance

    istioctl deregister <svcname> <ip> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    # de-register an endpoint 172.17.0.2 from service my-svc:
    istioctl deregister my-svc 172.17.0.2

## istioctl experimental

Experimental commands that may be modified or deprecated

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

## istioctl experimental add-to-mesh

Add workloads into Istio service mesh

    istioctl experimental add-to-mesh [flags]

    istioctl experimental add [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

## istioctl experimental add-to-mesh external-service

istioctl experimental add-to-mesh external-service create a ServiceEntry and\ a Service without selector for the specified external service in Istio service mesh. The typical usage scenario is Mesh Expansion on VMs. THIS COMMAND IS STILL UNDER ACTIVE DEVELOPMENT AND NOT READY FOR PRODUCTION USE.

    istioctl experimental add-to-mesh external-service <svcname> <ip>... [name1:]port1 [name2:]port2 ... [flags]

Flags | Shorthand | Description
--- | --- | ---
`--annotations <stringSlice>` | `-a` | List of string annotations to apply if creating a service/endpoint; e.g. -a foo=bar,x=y (default `[]`)
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--labels <stringSlice>` | `-l` | List of labels to apply if creating a service/endpoint; e.g. -l env=prod,vers=2 (default `[]`)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--serviceaccount <string>` | `-s` | Service account to link to the service (default `default`)

### Examples

    istioctl experimental add-to-mesh external-service vmhttp 172.12.23.125,172.12.23.126\
    http:9080 tcp:8888 -l app=test,version=v1 -a env=stage -s stageAdmin

## istioctl experimental add-to-mesh service

istioctl experimental add-to-mesh service restarts pods with the Istio sidecar. Use 'add-to-mesh' to test deployments for compatibility with Istio. If your service does not function after using 'add-to-mesh' you must re-deploy it and troubleshoot it for Istio compatibility. See https://istio.io/docs/setup/kubernetes/additional-setup/requirements/ THIS COMMAND IS STILL UNDER ACTIVE DEVELOPMENT AND NOT READY FOR PRODUCTION USE.

    istioctl experimental add-to-mesh service [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--injectConfigFile <string>` |  | injection configuration filename. Cannot be used with --injectConfigMapName (default ``)
`--injectConfigMapName <string>` |  | ConfigMap name for Istio sidecar injection, key should be "config". (default `istio-sidecar-injector`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--meshConfigFile <string>` |  | mesh configuration filename. Takes precedence over --meshConfigMapName if set (default ``)
`--meshConfigMapName <string>` |  | ConfigMap name for Istio mesh configuration, key should be "mesh" (default `istio`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--valuesFile <string>` |  | injection values configuration filename. (default ``)

### Examples

    istioctl experimental add-to-mesh service productpage

## istioctl experimental analyze

Analyze Istio configuration and print validation messages (analyze has graduated. Use `istioctl analyze`)

    istioctl experimental analyze <file>... [flags]

Flags | Shorthand | Description
--- | --- | ---
`--all-namespaces` |  | Analyze all namespaces
`--color` |  | Default true. Disable with '=false' or set $TERM to dumb
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--discovery` | `-d` | 'true' to enable service discovery, 'false' to disable it. Defaults to true if --use-kube is set, false otherwise. Analyzers requiring resources made available by enabling service discovery will be skipped.
`--failure-threshold <Level>` |  | The severity level of analysis at which to set a non-zero exit code. Valid values: [Info Warn Error] (default `Warn`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--list-analyzers` | `-L` | List the analyzers available to run. Suppresses normal execution.

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--meshConfigFile <string>` |  | Overrides the mesh config values to use for analysis. (default ``)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of [yaml log json] (default `log`)
`--output-threshold <Level>` |  | The severity level of analysis at which to display messages. Valid values: [Info Warn Error] (default `Info`)
`--use-kube` | `-k` | Use live Kubernetes cluster for analysis
`--verbose` | `-v` | Enable verbose output

### Examples

    # Analyze yaml files
    istioctl analyze a.yaml b.yaml

    # Analyze the current live cluster
    istioctl analyze -k

    # Analyze the current live cluster, simulating the effect of applying additional yaml files
    istioctl analyze -k a.yaml b.yaml

    # Analyze yaml files, overriding service discovery to enabled
    istioctl analyze -d true a.yaml b.yaml services.yaml

    # Analyze the current live cluster, overriding service discovery to disabled
    istioctl analyze -k -d false

    # List available analyzers
    istioctl analyze -L

## istioctl experimental authz

Commands to inspect and interact with the authorization policies check - check Envoy config dump for authorization configuration convert - convert v1alpha1 RBAC policies to v1beta1 authorization policies

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

      # Check Envoy authorization configuration for pod httpbin-88ddbcfdd-nt5jb:
      istioctl x authz check httpbin-88ddbcfdd-nt5jb

      # Convert the v1alpha1 RBAC policies in the current cluster to v1beta1 authorization policies:
      istioctl x authz convert > v1beta1-authz.yaml

## istioctl experimental authz check

Check reads the Envoy config dump and checks the filter configuration related to authorization. For example, it shows whether or not the Envoy is configured with authorization and the rules used in the authorization.

The Envoy config dump could be provided either by pod name or from a config dump file (the whole output of http://localhost:15000/config_dump of an Envoy instance).

THIS COMMAND IS STILL UNDER ACTIVE DEVELOPMENT AND NOT READY FOR PRODUCTION USE.

    istioctl experimental authz check <pod-name>[.<pod-namespace>] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--all` | `-a` | Show additional information (e.g. SNI and ALPN)
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--file <string>` | `-f` | Check the Envoy config dump from a file (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

      # Check Envoy authorization configuration for pod httpbin-88ddbcfdd-nt5jb:
      istioctl x authz check httpbin-88ddbcfdd-nt5jb

      # Check Envoy authorization configuration from a config dump file:
      istioctl x authz check -f httpbin_config_dump.json

## istioctl experimental authz convert

Convert Istio v1alpha1 RBAC policy to v1beta1 authorization policy. The command talks to Kubernetes API server to get all the information needed to complete the conversion, including the v1alpha1 RBAC policies in the current cluster, the Istio config-map for root namespace configuration and the k8s Service translating the service name to workload selector.

The tool can also be used in offline mode without talking to the Kubernetes API server. In this mode, all needed information is provided through the command line.

Note: The converter tool makes a best effort attempt to keep the syntax unchanged when converting v1alph1 RBAC policy to v1beta1 policy. However, in some cases, strict mapping with equivalent syntax is not possible (e.g., constraints no longer valid in the new workload oriented model, converting a service name containing a wildcard to workload selector).

Please always review the converted policies, and remove the "===PLEASE REVIEW THE GENERATED POLICY AND REMOVE THIS LINE BEFORE APPLYING IT===" string on top of the converted policies before apply them.

THIS COMMAND IS STILL UNDER ACTIVE DEVELOPMENT AND NOT READY FOR PRODUCTION USE.

    istioctl experimental authz convert [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--file <stringSlice>` | `-f` | v1alpha1 RBAC policy that needs to be converted to v1beta1 authorization policy (default `[]`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--meshConfigFile <string>` | `-m` | Istio MeshConfig file that provides the root namespace value (default ``)
`--meshConfigMapName <string>` |  | ConfigMap name for Istio mesh configuration (default `istio`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--service <stringSlice>` | `-s` | Kubernetes Service resource that provides the mapping between service and workload (default `[]`)

### Examples

      # Convert the v1alpha1 RBAC policy in the current cluster:
      istioctl x authz convert > v1beta1-authz.yaml

      # Convert the v1alpha1 RBAC policy provided through command line:
      istioctl x authz convert -f v1alpha1-policy-1.yaml,v1alpha1-policy-2.yaml
      --service services.yaml --meshConfigFile meshConfig.yaml > v1beta1-authz.yaml

## istioctl experimental convert-ingress

(convert-ingress has graduated. Use `istioctl convert-ingress`)

    istioctl experimental convert-ingress [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

## istioctl experimental create-remote-secret

Create a secret with credentials to allow Istio to access remote Kubernetes apiservers

    istioctl experimental create-remote-secret <cluster-name> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--auth-plugin-config <stringToString>` |  | authenticator plug-in configuration. --auth-type=plugin must be set with this option (default `[]`)
`--auth-plugin-name <string>` |  | authenticator plug-in name. --auth-type=plugin must be set with this option (default ``)
`--auth-type <RemoteSecretAuthType>` |  | type of authentication to use. supported values = [bearer-token plugin] (default `bearer-token`)
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--service-account <string>` |  | create a secret with this service account's credentials. (default `istio-reader-service-account`)

### Examples

    # Create a secret to access cluster c0's apiserver and install it in cluster c1.
    istioctl --Kubeconfig=c0.yaml x create-remote-secret \
        | kubectl -n istio-system --Kubeconfig=c1.yaml apply -f -

    # Delete a secret that was previously installed in c1
    istioctl --Kubeconfig=c0.yaml x create-remote-secret \
        | kubectl -n istio-system --Kubeconfig=c1.yaml delete -f -

    # Create a secret  access a remote cluster with an auth plugin
    istioctl --Kubeconfig=c0.yaml x create-remote-secret --auth-type=plugin --auth-plugin-name=gcp \
        | kubectl -n istio-system --Kubeconfig=c1.yaml apply -f -

## istioctl experimental dashboard

(dashboard has graduated. Use `istioctl dashboard`)

    istioctl experimental dashboard [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

## istioctl experimental describe

Describe resource and related Istio configuration

    istioctl experimental describe [flags]

    istioctl experimental des [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

## istioctl experimental describe pod

Analyzes pod, its Services, DestinationRules, and VirtualServices and reports the configuration objects that affect that pod.

THIS COMMAND IS STILL UNDER ACTIVE DEVELOPMENT AND NOT READY FOR PRODUCTION USE.

    istioctl experimental describe pod <pod> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--ignoreUnmeshed` |  | Suppress warnings for unmeshed pods
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    istioctl experimental describe pod productpage-v1-c7765c886-7zzd4

## istioctl experimental describe service

Analyzes service, pods, DestinationRules, and VirtualServices and reports the configuration objects that affect that service.

THIS COMMAND IS STILL UNDER ACTIVE DEVELOPMENT AND NOT READY FOR PRODUCTION USE.

    istioctl experimental describe service <svc> [flags]

    istioctl experimental describe svc <svc> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--ignoreUnmeshed` |  | Suppress warnings for unmeshed pods
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    istioctl experimental describe service productpage

## istioctl experimental kube-uninject

kube-uninject is used to prevent Istio from adding a sidecar and also provides the inverse of "istioctl kube-inject -f".

    istioctl experimental kube-uninject [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--filename <string>` | `-f` | Input Kubernetes resource filename (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Modified output Kubernetes resource filename (default ``)

### Examples

    # Update resources before applying.
    kubectl apply -f <(istioctl experimental kube-uninject -f <resource.yaml>)

    # Create a persistent version of the deployment by removing Envoy sidecar.
    istioctl experimental kube-uninject -f deployment.yaml -o deployment-uninjected.yaml

    # Update an existing deployment.
    kubectl get deployment -o yaml | istioctl experimental kube-uninject -f - | kubectl apply -f -

## istioctl experimental metrics

Prints the metrics for the specified service(s) when running in Kubernetes.

This command finds a Prometheus pod running in the specified istio system namespace. It then executes a series of queries per requested workload to find the following top-level workload metrics: total requests per second, error rate, and request latency at p50, p90, and p99 percentiles. The query results are printed to the console, organized by workload name.

All metrics returned are from server-side reports. This means that latencies and error rates are from the perspective of the service itself and not of an individual client (or aggregate set of clients). Rates and latencies are calculated over a time interval of 1 minute.

    istioctl experimental metrics <workload name>...

    istioctl experimental m <workload name>...

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    # Retrieve workload metrics for productpage-v1 workload
    istioctl experimental metrics productpage-v1

    # Retrieve workload metrics for various services in the different namespaces
    istioctl experimental metrics productpage-v1.foo reviews-v1.bar ratings-v1.baz

## istioctl experimental multicluster

Commands to assist in managing a multi-cluster mesh

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

## istioctl experimental multicluster apply

Update clusters in a multi-cluster mesh based on mesh topology

    istioctl experimental multicluster apply  -f <mesh.yaml> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--filename <string>` | `-f` | filename of the multicluster mesh description (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

## istioctl experimental multicluster describe

Describe status of the multi-cluster mesh's control plane'

    istioctl experimental multicluster describe -f <mesh.yaml> [--all] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--all` |  | describe the status of all clustersByContext in the mesh
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--filename <string>` | `-f` | filename of the multicluster mesh description (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

## istioctl experimental multicluster generate

generate a cluster-specific control plane configuration based on the mesh description and runtime state

    istioctl experimental multicluster generate -f <mesh.yaml> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--filename <string>` | `-f` | filename of the multicluster mesh description (default ``)
`--from <string>` |  | optional source configuration to generate multicluster aware configuration from (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--wait-for-gateways` |  | wait for all cluster's istio-ingressgateway IPs to be ready before generating configuration.

## istioctl experimental post-install

Commands related to post-install

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

## istioctl experimental post-install webhook

webhook command to manage webhook configurations

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

## istioctl experimental post-install webhook disable

Disable webhook configurations

    istioctl experimental post-install webhook disable [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--injection` |  | Disable mutating webhook (default true).
`--injection-config <string>` |  | The mutating webhook configuration to disable. (default `istio-sidecar-injector`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--validation` |  | Disable validating webhook (default true).
`--validation-config <string>` |  | The validating webhook configuration to disable. (default `istio-galley`)

### Examples

    # Disable all webhooks
    istioctl experimental post-install webhook disable

    # Disable all webhooks except injection
    istioctl experimental post-install webhook disable --injection=false

## istioctl experimental post-install webhook enable

This command is used to enable webhook configurations after installing Istio. For previous Istio versions (e.g., 1.2, 1.3, etc), this command is not needed because in previous versions webhooks manage their own configurations.

    istioctl experimental post-install webhook enable [flags]

Flags | Shorthand | Description
--- | --- | ---

`--ca-bundle-file <string>`

PEM encoded CA bundle which will be used to validate the webhook's server certificates. If this is empty, the kube-apisever's root CA is used if it can be confirmed to have signed the webhook's certificates. This condition is sometimes true but is not guaranteed (see https://kubernetes.io/docs/reference/command-line-tools-reference/kubelet-tls-bootstrapping) (default ``)

`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--injection` |  | Enable injection webhook (default true).
`--injection-path <string>` |  | The file path of the injection webhook configuration. (default ``)
`--injection-service <string>` |  | The service name of the injection webhook to manage. (default `istio-sidecar-injector`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--read-cert-timeout <duration>` |  | Max time for waiting the webhook certificate to be readable. (default `1m0s`)
`--timeout <duration>` |  | Max time for checking the validating webhook server. If the validating webhook server is not readyin the given time, exit. Otherwise, apply the webhook configuration. (default `1m0s`)
`--validation` |  | Enable validatation webhook (default true).
`--validation-path <string>` |  | The file path of the validation webhook configuration. (default ``)
`--validation-service <string>` |  | The service name of the validation webhook to manage. (default `istio-galley`)
`--webhook-secret <string>` |  | The name of an existing Kubernetes secret of a webhook. istioctl will verify that the webhook certificate is issued by the CA certificate. (default ``)

### Examples

    # Enable the webhook configuration of Galley with the given webhook configuration
    istioctl experimental post-install webhook enable --validation --webhook-secret istio.webhook.galley
        --namespace istio-system --validation-path validatingwebhookconfiguration.yaml

    # Enable the webhook configuration of Galley with the given webhook configuration and CA certificate
    istioctl experimental post-install webhook enable --validation --webhook-secret istio.webhook.galley
        --namespace istio-system --validation-path validatingwebhookconfiguration.yaml --ca-bundle-file ./k8s-ca-cert.pem

## istioctl experimental post-install webhook status

Get webhook configurations

    istioctl experimental post-install webhook status [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--injection` |  | Display the injection webhook configuration.
`--injection-config <string>` |  | The name of the MutatingWebhookConfiguration to display. (default `istio-sidecar-injector`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--validation` |  | Display the validating webhook configuration.
`--validation-config <string>` |  | The name of the ValidatingWebhookConfiguration to display. (default `istio-galley`)

### Examples

    # Display the webhook configuration of Galley
    istioctl experimental post-install webhook status --validation --validation-config istio-galley
    # Display the webhook configuration of Galley and Sidecar Injector
    istioctl experimental post-install webhook status --validation --validation-config istio-galley
      --injection --injection-config istio-sidecar-injector

## istioctl experimental remove-from-mesh

Remove workloads from Istio service mesh

    istioctl experimental remove-from-mesh [flags]

    istioctl experimental rm [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

## istioctl experimental remove-from-mesh external-service

istioctl experimental remove-from-mesh external-service remove the ServiceEntry and\ the kubernetes Service for the specified external service(eg:services running on VM) from Istio service mesh. The typical usage scenario is Mesh Expansion on VMs. THIS COMMAND IS STILL UNDER ACTIVE DEVELOPMENT AND NOT READY FOR PRODUCTION USE.

    istioctl experimental remove-from-mesh external-service <svcname> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    istioctl experimental remove-from-mesh external-service vmhttp

## istioctl experimental remove-from-mesh service

istioctl experimental remove-from-mesh service restarts pods with the Istio sidecar un-injected. THIS COMMAND IS STILL UNDER ACTIVE DEVELOPMENT AND NOT READY FOR PRODUCTION USE.

    istioctl experimental remove-from-mesh service [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)

### Examples

    istioctl experimental remove-from-mesh service productpage

## istioctl experimental upgrade

The upgrade command checks for upgrade version eligibility and, if eligible, upgrades the Istio control plane components in-place. Warning: traffic may be disrupted during upgrade. Please ensure PodDisruptionBudgets are defined to maintain service continuity.

    istioctl experimental upgrade [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--dry-run` |  | Console/log output only, make no changes.
`--filename <string>` | `-f` | Path to file containing IstioControlPlane CustomResource (default ``)
`--force` |  | Apply the upgrade without eligibility checks and testing for changes in profile default values
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--logtostderr` |  | Send logs to stderr.
`--namespace <string>` | `-n` | Config namespace (default ``)
`--skip-confirmation` |  | If skip-confirmation is set, skips the prompting confirmation for value changes in this upgrade
`--verbose` |  | Verbose output.
`--versionsURI <string>` | `-u` | URI for operator versions to Istio versions map (default `https://raw.githubusercontent.com/istio/operator/master/data/versions.yaml`)
`--wait` | `-w` | Wait, if set will wait until all Pods, Services, and minimum number of Pods of a Deployment are in a ready state before the command exits. It will wait for a maximum duration of 10m0s

## istioctl experimental wait

Waits for the specified condition to be true of an Istio resource.

    istioctl experimental wait [flags] <type> <name>[.<namespace>]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--for <string>` |  | wait condition, must be 'distribution' or 'delete' (default `distribution`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--resource-version <string>` |  | wait for a specific version of config to become current, rather than using whatever is latest in kubernetes (default ``)
`--threshold <float32>` |  | the ratio of distribution required for success (default `1`)
`--timeout <duration>` |  | the duration to wait before failing (default `30s`)

### Examples

    # Wait until the bookinfo virtual service has been distributed to all proxies in the mesh
    istioctl experimental wait --for=distribution virtualservice bookinfo.default

    # Wait until 99% of the proxies receive the distribution, timing out after 5 minutes
    istioctl experimental wait --for=distribution --threshold=.99 --timeout=300 virtualservice bookinfo.default

## istioctl kube-inject

kube-inject manually injects the Envoy sidecar into Kubernetes workloads. Unsupported resources are left unmodified so it is safe to run kube-inject over a single file that contains multiple Service, ConfigMap, Deployment, etc. definitions for a complex application. It's best to do this when the resource is initially created.

k8s.io/docs/concepts/workloads/pods/pod-overview/#pod-templates is updated for Job, DaemonSet, ReplicaSet, Pod and Deployment YAML resource documents. Support for additional pod-based resource types can be added as necessary.

The Istio project is continually evolving so the Istio sidecar configuration may change unannounced. When in doubt re-run istioctl kube-inject on deployments to get the most up-to-date changes.

    istioctl kube-inject [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--filename <string>` | `-f` | Input Kubernetes resource filename (default ``)
`--injectConfigFile <string>` |  | injection configuration filename. Cannot be used with --injectConfigMapName (default ``)
`--injectConfigMapName <string>` |  | ConfigMap name for Istio sidecar injection, key should be "config". (default `istio-sidecar-injector`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--meshConfigFile <string>` |  | mesh configuration filename. Takes precedence over --meshConfigMapName if set (default ``)
`--meshConfigMapName <string>` |  | ConfigMap name for Istio mesh configuration, key should be "mesh" (default `istio`)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Modified output Kubernetes resource filename (default ``)
`--valuesFile <string>` |  | injection values configuration filename. (default ``)

### Examples

    # Update resources on the fly before applying.
    kubectl apply -f <(istioctl kube-inject -f <resource.yaml>)

    # Create a persistent version of the deployment with Envoy sidecar
    # injected.
    istioctl kube-inject -f deployment.yaml -o deployment-injected.yaml

    # Update an existing deployment.
    kubectl get deployment -o yaml | istioctl kube-inject -f - | kubectl apply -f -

    # Capture cluster configuration for later use with kube-inject
    kubectl -n istio-system get cm istio-sidecar-injector  -o jsonpath="{.data.config}" > /tmp/inj-template.tmpl
    kubectl -n istio-system get cm istio -o jsonpath="{.data.mesh}" > /tmp/mesh.yaml
    kubectl -n istio-system get cm istio-sidecar-injector -o jsonpath="{.data.values}" > /tmp/values.json
    # Use kube-inject based on captured configuration
    istioctl kube-inject -f samples/bookinfo/platform/kube/bookinfo.yaml \
    	--injectConfigFile /tmp/inj-template.tmpl \
    	--meshConfigFile /tmp/mesh.yaml \
    	--valuesFile /tmp/values.json

## istioctl manifest

The manifest subcommand generates, applies, diffs or migrates Istio manifests.

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--dry-run` |  | Console/log output only, make no changes.
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--logtostderr` |  | Send logs to stderr.
`--namespace <string>` | `-n` | Config namespace (default ``)
`--verbose` |  | Verbose output.

## istioctl manifest apply

The apply subcommand generates an Istio install manifest and applies it to a cluster.

    istioctl manifest apply [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--dry-run` |  | Console/log output only, make no changes.
`--filename <string>` | `-f` | Path to file containing IstioControlPlane CustomResource (default ``)
`--force` |  | Proceed even with validation errors
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--logtostderr` |  | Send logs to stderr.
`--namespace <string>` | `-n` | Config namespace (default ``)
`--readiness-timeout <duration>` |  | Maximum seconds to wait for all Istio resources to be ready. The --wait flag must be set for this flag to apply (default `5m0s`)
`--set <stringSlice>` | `-s` | Set a value in IstioControlPlane CustomResource. e.g. --set policy.enabled=true. Overrides the corresponding path value in the selected profile or passed through IstioControlPlane CR customization file (default `[]`)
`--skip-confirmation` |  | skipConfirmation determines whether the user is prompted for confirmation. If set to true, the user is not prompted and a Yes response is assumed in all cases.
`--verbose` |  | Verbose output.
`--wait` | `-w` | Wait, if set will wait until all Pods, Services, and minimum number of Pods of a Deployment are in a ready state before the command exits. It will wait for a maximum duration of --readiness-timeout seconds

## istioctl manifest diff

The diff subcommand compares manifests from two files or directories.

    istioctl manifest diff <file|dir> <file|dir> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--directory` | `-r` | compare directory
`--dry-run` |  | Console/log output only, make no changes.
`--ignore <string>` |  | ignoreResources ignores all listed items during comparison. It uses the same list format as selectResources (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--logtostderr` |  | Send logs to stderr.
`--namespace <string>` | `-n` | Config namespace (default ``)
`--rename <string>` |  | renameResources identifies renamed resources before comparison. The format of each renaming pair is A->B, all renaming pairs are comma separated. e.g. Service:*:istio-pilot->Service:*:istio-control - rename istio-pilot service into istio-control (default ``)

`--select <string>`

selectResources constrains the list of resources to compare to only the ones in this list, ignoring all others. The format of each list item is "::" and the items are comma separated. The "*" character represents wildcard selection. e.g. Deployment:istio-system:* - compare all deployments in istio-system namespace Service:*:istio-pilot - compare Services called "istio-pilot" in all namespaces (default `::`)

`--verbose` |  | Verbose output.

## istioctl manifest generate

The generate subcommand generates an Istio install manifest and outputs to the console by default.

    istioctl manifest generate [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--dry-run` |  | Console/log output only, make no changes.
`--filename <string>` | `-f` | Path to file containing IstioControlPlane CustomResource (default ``)
`--force` |  | Proceed even with validation errors
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--logtostderr` |  | Send logs to stderr.
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Manifest output directory path (default ``)
`--set <stringSlice>` | `-s` | Set a value in IstioControlPlane CustomResource. e.g. --set policy.enabled=true. Overrides the corresponding path value in the selected profile or passed through IstioControlPlane CR customization file (default `[]`)
`--verbose` |  | Verbose output.

## istioctl manifest migrate

The migrate subcommand migrates a configuration from Helm values format to IstioControlPlane format.

    istioctl manifest migrate [<filepath>] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--dry-run` |  | Console/log output only, make no changes.
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--logtostderr` |  | Send logs to stderr.
`--namespace <string>` | `-n` | Config namespace (default ``)
`--verbose` |  | Verbose output.

## istioctl manifest versions

List the versions of Istio recommended for use or supported for upgrade by this version of the operator binary.

    istioctl manifest versions [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--dry-run` |  | Console/log output only, make no changes.
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--logtostderr` |  | Send logs to stderr.
`--namespace <string>` | `-n` | Config namespace (default ``)
`--verbose` |  | Verbose output.
`--versionsURI <string>` | `-u` | URI for operator versions to Istio versions map (default `https://raw.githubusercontent.com/istio/operator/master/data/versions.yaml`)

## istioctl profile

The profile subcommand lists, dumps or diffs Istio configuration profiles.

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--dry-run` |  | Console/log output only, make no changes.
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--logtostderr` |  | Send logs to stderr.
`--namespace <string>` | `-n` | Config namespace (default ``)
`--verbose` |  | Verbose output.

## istioctl profile diff

The diff subcommand displays the differences between two Istio configuration profiles.

    istioctl profile diff <file1.yaml> <file2.yaml> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--dry-run` |  | Console/log output only, make no changes.
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--logtostderr` |  | Send logs to stderr.
`--namespace <string>` | `-n` | Config namespace (default ``)
`--verbose` |  | Verbose output.

## istioctl profile dump

The dump subcommand dumps the values in an Istio configuration profile.

    istioctl profile dump [<profile>] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--config-path <string>` | `-p` | The path the root of the configuration subtree to dump e.g. trafficManagement.components.pilot. By default, dump whole tree (default ``)
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--dry-run` |  | Console/log output only, make no changes.
`--filename <string>` | `-f` | Path to file containing IstioControlPlane CustomResource (default ``)
`--helm-values` |  | If set, dumps the Helm values that IstioControlPlaceSpec is translated to before manifests are rendered
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--logtostderr` |  | Send logs to stderr.
`--namespace <string>` | `-n` | Config namespace (default ``)
`--verbose` |  | Verbose output.

## istioctl profile list

The list subcommand lists the available Istio configuration profiles.

    istioctl profile list [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--dry-run` |  | Console/log output only, make no changes.
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--logtostderr` |  | Send logs to stderr.
`--namespace <string>` | `-n` | Config namespace (default ``)
`--verbose` |  | Verbose output.

## istioctl proxy-config

A group of commands used to retrieve information about proxy configuration from the Envoy config dump

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)

### Examples

      # Retrieve information about proxy configuration from an Envoy instance.
      istioctl proxy-config <clusters|listeners|routes|endpoints|bootstrap> <pod-name[.namespace]>

## istioctl proxy-config bootstrap

Retrieve information about bootstrap configuration for the Envoy instance in the specified pod.

    istioctl proxy-config bootstrap [<pod-name[.namespace]>] [flags]

    istioctl proxy-config b [<pod-name[.namespace]>] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--file <string>` | `-f` | Envoy config dump JSON file (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)

### Examples

      # Retrieve full bootstrap configuration for a given pod from Envoy.
      istioctl proxy-config bootstrap <pod-name[.namespace]>

      # Retrieve full bootstrap without using Kubernetes API
      ssh <user@hostname> 'curl localhost:15000/config_dump' > envoy-config.json
      istioctl proxy-config bootstrap --file envoy-config.json

## istioctl proxy-config cluster

Retrieve information about cluster configuration for the Envoy instance in the specified pod.

    istioctl proxy-config cluster [<pod-name[.namespace]>] [flags]

    istioctl proxy-config clusters [<pod-name[.namespace]>] [flags]
    istioctl proxy-config c [<pod-name[.namespace]>] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--direction <string>` |  | Filter clusters by Direction field (default ``)
`--file <string>` | `-f` | Envoy config dump JSON file (default ``)
`--fqdn <string>` |  | Filter clusters by substring of Service FQDN field (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)
`--port <int>` |  | Filter clusters by Port field (default `0`)
`--subset <string>` |  | Filter clusters by substring of Subset field (default ``)

### Examples

      # Retrieve summary about cluster configuration for a given pod from Envoy.
      istioctl proxy-config clusters <pod-name[.namespace]>

      # Retrieve cluster summary for clusters with port 9080.
      istioctl proxy-config clusters <pod-name[.namespace]> --port 9080

      # Retrieve full cluster dump for clusters that are inbound with a FQDN of details.default.svc.cluster.local.
      istioctl proxy-config clusters <pod-name[.namespace]> --fqdn details.default.svc.cluster.local --direction inbound -o json

      # Retrieve cluster summary without using Kubernetes API
      ssh <user@hostname> 'curl localhost:15000/config_dump' > envoy-config.json
      istioctl proxy-config clusters --file envoy-config.json

## istioctl proxy-config endpoint

Retrieve information about endpoint configuration for the Envoy instance in the specified pod.

    istioctl proxy-config endpoint [<pod-name[.namespace]>] [flags]

    istioctl proxy-config endpoints [<pod-name[.namespace]>] [flags]
    istioctl proxy-config ep [<pod-name[.namespace]>] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--address <string>` |  | Filter endpoints by address field (default ``)
`--cluster <string>` |  | Filter endpoints by cluster name field (default ``)
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--file <string>` | `-f` | Envoy config dump JSON file (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)
`--port <int>` |  | Filter endpoints by Port field (default `0`)
`--status <string>` |  | Filter endpoints by status field (default ``)

### Examples

      # Retrieve full endpoint configuration for a given pod from Envoy.
      istioctl proxy-config endpoint <pod-name[.namespace]>

      # Retrieve endpoint summary for endpoint with port 9080.
      istioctl proxy-config endpoint <pod-name[.namespace]> --port 9080

      # Retrieve full endpoint with a address (172.17.0.2).
      istioctl proxy-config endpoint <pod-name[.namespace]> --address 172.17.0.2 -o json

      # Retrieve full endpoint with a cluster name (outbound|9411||zipkin.istio-system.svc.cluster.local).
      istioctl proxy-config endpoint <pod-name[.namespace]> --cluster "outbound|9411||zipkin.istio-system.svc.cluster.local" -o json
      # Retrieve full endpoint with the status (healthy).
      istioctl proxy-config endpoint <pod-name[.namespace]> --status healthy -ojson

      # Retrieve endpoint summary without using Kubernetes API
      ssh <user@hostname> 'curl localhost:15000/clusters?format=json' > envoy-clusters.json
      istioctl proxy-config endpoints --file envoy-clusters.json

## istioctl proxy-config listener

Retrieve information about listener configuration for the Envoy instance in the specified pod.

    istioctl proxy-config listener [<pod-name[.namespace]>] [flags]

    istioctl proxy-config listeners [<pod-name[.namespace]>] [flags]
    istioctl proxy-config l [<pod-name[.namespace]>] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--address <string>` |  | Filter listeners by address field (default ``)
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--file <string>` | `-f` | Envoy config dump JSON file (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)
`--port <int>` |  | Filter listeners by Port field (default `0`)
`--type <string>` |  | Filter listeners by type field (default ``)

### Examples

      # Retrieve summary about listener configuration for a given pod from Envoy.
      istioctl proxy-config listeners <pod-name[.namespace]>

      # Retrieve listener summary for listeners with port 9080.
      istioctl proxy-config listeners <pod-name[.namespace]> --port 9080

      # Retrieve full listener dump for HTTP listeners with a wildcard address (0.0.0.0).
      istioctl proxy-config listeners <pod-name[.namespace]> --type HTTP --address 0.0.0.0 -o json

      # Retrieve listener summary without using Kubernetes API
      ssh <user@hostname> 'curl localhost:15000/config_dump' > envoy-config.json
      istioctl proxy-config listeners --file envoy-config.json

## istioctl proxy-config log

(experimental) Retrieve information about logging levels of the Envoy instance in the specified pod, and update optionally

    istioctl proxy-config log <pod-name[.namespace]> [flags]

    istioctl proxy-config o <pod-name[.namespace]> [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--level <string>`

Comma-separated minimum per-logger level of messages to output, in the form of [<logger>:]<level>,[<logger>:]<level>,... where logger can be one of admin, aws, assert, backtrace, client, config, connection, conn_handler, dubbo, file, filter, forward_proxy, grpc, hc, health_checker, http, http2, hystrix, init, io, jwt, kafka, lua, main, misc, mongo, quic, pool, rbac, redis, router, runtime, stats, secret, tap, testing, thrift, tracing, upstream, udp, wasm and level can be one of [trace, debug, info, warning, error, critical, off] (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)
`--reset` | `-r` | Reset levels to default value (warning).

### Examples

      # Retrieve information about logging levels for a given pod from Envoy.
      istioctl proxy-config log <pod-name[.namespace]>

      # Update levels of the all loggers
      istioctl proxy-config log <pod-name[.namespace]> --level none

      # Update levels of the specified loggers.
      istioctl proxy-config log <pod-name[.namespace]> --level http:debug,redis:debug

      # Reset levels of all the loggers to default value (warning).
      istioctl proxy-config log <pod-name[.namespace]> -r

## istioctl proxy-config route

Retrieve information about route configuration for the Envoy instance in the specified pod.

    istioctl proxy-config route [<pod-name[.namespace]>] [flags]

    istioctl proxy-config routes [<pod-name[.namespace]>] [flags]
    istioctl proxy-config r [<pod-name[.namespace]>] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--file <string>` | `-f` | Envoy config dump JSON file (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--name <string>` |  | Filter listeners by route name field (default ``)
`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)

### Examples

      # Retrieve summary about route configuration for a given pod from Envoy.
      istioctl proxy-config routes <pod-name[.namespace]>

      # Retrieve route summary for route 9080.
      istioctl proxy-config route <pod-name[.namespace]> --name 9080

      # Retrieve full route dump for route 9080
      istioctl proxy-config route <pod-name[.namespace]> --name 9080 -o json

      # Retrieve route summary without using Kubernetes API
      ssh <user@hostname> 'curl localhost:15000/config_dump' > envoy-config.json
      istioctl proxy-config routes --file envoy-config.json

## istioctl proxy-config secret

(experimental) Retrieve information about secret configuration for the Envoy instance in the specified pod.

    istioctl proxy-config secret [<pod-name[.namespace]>] [flags]

    istioctl proxy-config s [<pod-name[.namespace]>] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--file <string>` | `-f` | Envoy config dump JSON file (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | Output format: one of json|short (default `short`)

### Examples

      # Retrieve full secret configuration for a given pod from Envoy.
      istioctl proxy-config secret <pod-name[.namespace]>

      # Retrieve full bootstrap without using Kubernetes API
      ssh <user@hostname> 'curl localhost:15000/config_dump' > envoy-config.json
      istioctl proxy-config secret --file envoy-config.json

    THIS COMMAND IS STILL UNDER ACTIVE DEVELOPMENT AND NOT READY FOR PRODUCTION USE.

## istioctl proxy-status

Retrieves last sent and last acknowledged xDS sync from Pilot to each Envoy in the mesh

    istioctl proxy-status [<pod-name[.namespace]>] [flags]

    istioctl ps [<pod-name[.namespace]>] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--sds` | `-s` | (experimental) Retrieve synchronization between active secrets on Envoy instance with those on corresponding node agents
`--sds-json` |  | Determines whether SDS dump outputs JSON

### Examples

    # Retrieve sync status for all Envoys in a mesh
    	istioctl proxy-status

    # Retrieve sync diff for a single Envoy and Pilot
    	istioctl proxy-status istio-egressgateway-59585c5b9c-ndc59.istio-system

## istioctl register

Registers a service instance (e.g. VM) joining the mesh

    istioctl register <svcname> <ip> [name1:]port1 [name2:]port2 ... [flags]

Flags | Shorthand | Description
--- | --- | ---
`--annotations <stringSlice>` | `-a` | List of string annotations to apply if creating a service/endpoint; e.g. -a foo=bar,test,x=y (default `[]`)
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)
`--labels <stringSlice>` | `-l` | List of labels to apply if creating a service/endpoint; e.g. -l env=prod,vers=2 (default `[]`)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--serviceaccount <string>` | `-s` | Service account to link to the service (default `default`)

## istioctl validate

Validate Istio policy and rules (NOTE: validate is deprecated and will be removed in 1.6. Use 'istioctl analyze' to validate configuration.)

    istioctl validate -f FILENAME [options] [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--filename <stringSlice>` | `-f` | Names of files to validate (default `[]`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--referential` | `-x` | Enable structural validation for policy and telemetry

### Examples

    		# Validate bookinfo-gateway.yaml
    		istioctl validate -f bookinfo-gateway.yaml

    		# Validate current deployments under 'default' namespace within the cluster
    		kubectl get deployments -o yaml |istioctl validate -f -

    		# Validate current services under 'default' namespace within the cluster
    		kubectl get services -o yaml |istioctl validate -f -

    		# Also see the related command 'istioctl analyze'
    		istioctl analyze samples/bookinfo/networking/bookinfo-gateway.yaml

## istioctl verify-install

verify-install verifies Istio installation status against the installation file you specified when you installed Istio. It loops through all the installation resources defined in your installation file and reports whether all of them are in ready status. It will report failure when any of them are not ready.

If you do not specify installation file it will perform pre-check for your cluster and report whether the cluster is ready for Istio installation.

    istioctl verify-install [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--enableVerbose` |  | Enable verbose output
`--filename <stringSlice>` | `-f` | Istio YAML installation file. (default `[]`)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--recursive` | `-R` | Process the directory used in -f, --filename recursively. Useful when you want to manage related manifests organized within the same directory.

### Examples

    		# Verify that Istio can be freshly installed
    		istioctl verify-install

    		# Verify the deployment matches a custom Istio deployment configuration
    		istioctl verify-install -f $HOME/istio.yaml

## istioctl version

Prints out build version information

    istioctl version [flags]

Flags | Shorthand | Description
--- | --- | ---
`--context <string>` |  | The name of the kubeconfig context to use (default ``)
`--istioNamespace <string>` | `-i` | Istio system namespace (default `istio-system`)
`--kubeconfig <string>` | `-c` | Kubernetes configuration file (default ``)

`--log_output_level <string>`

Comma-separated minimum per-scope logging level of messages to output, in the form of <scope>:<level>,<scope>:<level>,... where scope can be one of [ads, all, analysis, attributes, authn, cacheLog, citadelClientLog, configMapController, conversions, default, googleCAClientLog, grpcAdapter, kube, kube-converter, mcp, meshconfig, model, patch, processing, rbac, resource, runtime, sdsServiceLog, secretFetcherLog, source, stsClientLog, tpath, translator, util, validation, vaultClientLog] and level can be one of [debug, info, warn, error, fatal, none] (default `default:info,validation:error,processing:error,source:error,analysis:warn`)

`--namespace <string>` | `-n` | Config namespace (default ``)
`--output <string>` | `-o` | One of 'yaml' or 'json'. (default ``)
`--remote` |  | Use --remote=false to suppress control plane check
`--short` | `-s` | Use --short=false to generate full version information

## Environment variables

These environment variables affect the behavior of the `istioctl` command.

Variable Name | Type | Default Value | Description
--- | --- | --- | ---
`BYPASS_OOP_MTLS_SAN_VERIFICATION` | Boolean | `false` | Whether or not to validate SANs for out-of-process adapters auth.
`GKE_CLUSTER_URL` | String | `` | The url of GKE cluster
`INGRESS_GATEWAY_FALLBACK_SECRET` | String | `gateway-fallback` |
`INGRESS_GATEWAY_NAMESPACE` | String | `` |
`ISTIOD_ADDR` | String | `` | Service name of istiod. If empty the istiod listener, certs will be disabled.
`ISTIO_GPRC_MAXSTREAMS` | Integer | `100000` | Sets the maximum number of concurrent grpc streams.
`ISTIO_LANG` | String | `` | Selects the attribute expression language runtime for Mixer.
`K8S_INGRESS_NS` | String | `` |
`NAMESPACE` | String | `istio-system` | namespace that nodeagent/citadel run in
`PILOT_BLOCK_HTTP_ON_443` | Boolean | `true` | If enabled, any HTTP services will be blocked on HTTPS port (443). If this is disabled, any HTTP service on port 443 could block all external traffic
`PILOT_CERT_DIR` | String | `` |
`PILOT_DEBOUNCE_AFTER` | Time Duration | `100ms` | The delay added to config/registry events for debouncing. This will delay the push by at least this internal. If no change is detected within this period, the push will happen, otherwise we'll keep delaying until things settle, up to a max of PILOT_DEBOUNCE_MAX.
`PILOT_DEBOUNCE_MAX` | Time Duration | `10s` | The maximum amount of time to wait for events while debouncing. If events keep showing up with no breaks for this time, we'll trigger a push.
`PILOT_DEBUG_ADSZ_CONFIG` | Boolean | `false` |
`PILOT_DISABLE_XDS_MARSHALING_TO_ANY` | Boolean | `false` |
`PILOT_DISTRIBUTION_HISTORY_RETENTION` | Time Duration | `1m0s` | If enabled, Pilot will keep track of old versions of distributed config for this duration.
`PILOT_ENABLE_CONFIG_DISTRIBUTION_TRACKING` | Boolean | `true` | If enabled, Pilot will assign meaningful nonces to each Envoy configuration message, and allow users to interrogate which envoy has which config from the debug interface.
`PILOT_ENABLE_CRD_VALIDATION` | Boolean | `false` | If enabled, pilot will validate CRDs while retrieving CRDs from kubernetes cache.Use this flag to enable validation of CRDs in Pilot, especially in deployments that do not have galley installed.
`PILOT_ENABLE_EDS_DEBOUNCE` | Boolean | `true` | If enabled, Pilot will include EDS pushes in the push debouncing, configured by PILOT_DEBOUNCE_AFTER and PILOT_DEBOUNCE_MAX. EDS pushes may be delayed, but there will be fewer pushes. By default this is enabled
`PILOT_ENABLE_FALLTHROUGH_ROUTE` | Boolean | `true` | EnableFallthroughRoute provides an option to add a final wildcard match for routes. When ALLOW_ANY traffic policy is used, a Passthrough cluster is used. When REGISTRY_ONLY traffic policy is used, a 502 error is returned.
`PILOT_ENABLE_HEADLESS_SERVICE_POD_LISTENERS` | Boolean | `true` | If enabled, for a headless service/stateful set in Kubernetes, pilot will generate an outbound listener for each pod in a headless service. This feature should be disabled if headless services have a large number of pods.
`PILOT_ENABLE_MYSQL_FILTER` | Boolean | `false` | EnableMysqlFilter enables injection of `envoy.filters.network.mysql_proxy` in the filter chain.
`PILOT_ENABLE_PROTOCOL_SNIFFING_FOR_INBOUND` | Boolean | `true` | If enabled, protocol sniffing will be used for inbound listeners whose port protocol is not specified or unsupported
`PILOT_ENABLE_PROTOCOL_SNIFFING_FOR_OUTBOUND` | Boolean | `true` | If enabled, protocol sniffing will be used for outbound listeners whose port protocol is not specified or unsupported
`PILOT_ENABLE_REDIS_FILTER` | Boolean | `false` | EnableRedisFilter enables injection of `envoy.filters.network.redis_proxy` in the filter chain.
`PILOT_ENABLE_UNSAFE_REGEX` | Boolean | `false` | If enabled, pilot will generate Envoy configuration that does not use safe_regex but the older, deprecated regex field. This should only be enabled to support legacy deployments that have not yet been migrated to the new safe regular expressions.
`PILOT_HTTP10` | Boolean | `false` | Enables the use of HTTP 1.0 in the outbound HTTP listeners, to support legacy applications.
`PILOT_INBOUND_PROTOCOL_DETECTION_TIMEOUT` | Time Duration | `1s` | Protocol detection timeout for inbound listener
`PILOT_INITIAL_FETCH_TIMEOUT` | Time Duration | `0s` | Specifies the initial_fetch_timeout for config. If this time is reached without a response to the config requested by Envoy, the Envoy will move on with the init phase. This prevents envoy from getting stuck waiting on config during startup.
`PILOT_PUSH_THROTTLE` | Integer | `100` | Limits the number of concurrent pushes allowed. On larger machines this can be increased for faster pushes
`PILOT_RESPECT_DNS_TTL` | Boolean | `true` | If enabled, DNS based clusters will respect the TTL of the DNS, rather than polling at a fixed rate. This option is only provided for backward compatibility purposes and will be removed in the near future.
`PILOT_RESTRICT_POD_UP_TRAFFIC_LOOP` | Boolean | `true` | If enabled, this will block inbound traffic from matching outbound listeners, which could result in an infinite loop of traffic. This option is only provided for backward compatibility purposes and will be removed in the near future.
`PILOT_SCOPE_GATEWAY_TO_NAMESPACE` | Boolean | `false` | If enabled, a gateway workload can only select gateway resources in the same namespace. Gateways with same selectors in different namespaces will not be applicable.
`PILOT_SCOPE_PUSHES` | Boolean | `true` | If enabled, pilot will attempt to limit unnecessary pushes by determining what proxies a config or endpoint update will impact.
`PILOT_SIDECAR_USE_REMOTE_ADDRESS` | Boolean | `false` | UseRemoteAddress sets useRemoteAddress to true for side car outbound listeners.
`PILOT_SKIP_VALIDATE_TRUST_DOMAIN` | Boolean | `false` | Skip validating the peer is from the same trust domain when mTLS is enabled in authentication policy
`PILOT_TRACE_SAMPLING` | Floating-Point | `100` | Sets the mesh-wide trace sampling percentage. Should be 0.0 - 100.0. Precision to 0.01. Default is 100, not recommended for production use.
`POD_NAME` | String | `` |
`SECRET_WATCHER_RESYNC_PERIOD` | String | `` |
`TERM` | String | `` | Specifies terminal type. Use 'dumb' to suppress color output
`TERMINATION_DRAIN_DURATION_SECONDS` | Integer | `5` | The amount of time allowed for connections to complete on pilot-agent shutdown. On receiving SIGTERM or SIGINT, pilot-agent tells the active Envoy to start draining, preventing any new connections and allowing existing connections to complete. It then sleeps for the TerminationDrainDuration and then kills any remaining active Envoy processes.
`USE_ISTIO_JWT_FILTER` | Boolean | `false` | Use the Istio JWT filter for JWT token verification.

## Exported metrics

Metric Name | Type | Description
--- | --- | ---
`endpoint_no_pod` | `LastValue` | Endpoints without an associated pod.
`galley_runtime_processor_event_span_duration_milliseconds` | `Distribution` | The duration between each incoming event
`galley_runtime_processor_events_processed_total` | `Count` | The number of events that have been processed
`galley_runtime_processor_snapshot_events_total` | `Distribution` | The number of events per snapshot
`galley_runtime_processor_snapshot_lifetime_duration_milliseconds` | `Distribution` | The duration of each snapshot
`galley_runtime_processor_snapshots_published_total` | `Count` | The number of snapshots that have been published
`galley_runtime_state_type_instances_total` | `LastValue` | The number of type instances per type URL
`galley_runtime_strategy_on_change_total` | `Count` | The number of times the strategy's onChange has been called
`galley_runtime_strategy_timer_max_time_reached_total` | `Count` | The number of times the max time has been reached
`galley_runtime_strategy_timer_quiesce_reached_total` | `Count` | The number of times a quiesce has been reached
`galley_runtime_strategy_timer_resets_total` | `Count` | The number of times the timer has been reset
`galley_source_kube_dynamic_converter_failure_total` | `Count` | The number of times a dynamnic kubernetes source failed converting a resources
`galley_source_kube_dynamic_converter_success_total` | `Count` | The number of times a dynamic kubernetes source successfully converted a resource
`galley_source_kube_event_error_total` | `Count` | The number of times a kubernetes source encountered errored while handling an event
`galley_source_kube_event_success_total` | `Count` | The number of times a kubernetes source successfully handled an event
`istio_build` | `LastValue` | Istio component build info
`istio_mcp_clients_total` | `LastValue` | The number of streams currently connected.
`istio_mcp_message_sizes_bytes` | `Distribution` | Size of messages received from clients.
`istio_mcp_reconnections` | `Sum` | The number of times the sink has reconnected.
`istio_mcp_recv_failures_total` | `Sum` | The number of recv failures in the source.
`istio_mcp_request_acks_total` | `Sum` | The number of request acks received by the source.
`istio_mcp_request_nacks_total` | `Sum` | The number of request nacks received by the source.
`istio_mcp_send_failures_total` | `Sum` | The number of send failures in the source.
`mixer_config_adapter_info_config_errors_total` | `LastValue` | The number of errors encountered during processing of the adapter info configuration.
`mixer_config_adapter_info_configs_total` | `LastValue` | The number of known adapters in the current config.
`mixer_config_attributes_total` | `LastValue` | The number of known attributes in the current config.
`mixer_config_handler_configs_total` | `LastValue` | The number of known handlers in the current config.
`mixer_config_handler_validation_error_total` | `LastValue` | The number of errors encountered because handler validation returned error.
`mixer_config_instance_config_errors_total` | `LastValue` | The number of errors encountered during processing of the instance configuration.
`mixer_config_instance_configs_total` | `LastValue` | The number of known instances in the current config.
`mixer_config_rule_config_errors_total` | `LastValue` | The number of errors encountered during processing of the rule configuration.
`mixer_config_rule_config_match_error_total` | `LastValue` | The number of rule conditions that was not parseable.
`mixer_config_rule_configs_total` | `LastValue` | The number of known rules in the current config.
`mixer_config_template_config_errors_total` | `LastValue` | The number of errors encountered during processing of the template configuration.
`mixer_config_template_configs_total` | `LastValue` | The number of known templates in the current config.
`mixer_config_unsatisfied_action_handler_total` | `LastValue` | The number of actions that failed due to handlers being unavailable.
`mixer_dispatcher_destinations_per_request` | `Distribution` | Number of handlers dispatched per request by Mixer
`mixer_dispatcher_destinations_per_variety_total` | `LastValue` | Number of Mixer adapter destinations by template variety type
`mixer_dispatcher_instances_per_request` | `Distribution` | Number of instances created per request by Mixer
`mixer_handler_closed_handlers_total` | `LastValue` | The number of handlers that were closed during config transition.
`mixer_handler_daemons_total` | `LastValue` | The current number of active daemon routines in a given adapter environment.
`mixer_handler_handler_build_failures_total` | `LastValue` | The number of handlers that failed creation during config transition.
`mixer_handler_handler_close_failures_total` | `LastValue` | The number of errors encountered while closing handlers during config transition.
`mixer_handler_new_handlers_total` | `LastValue` | The number of handlers that were newly created during config transition.
`mixer_handler_reused_handlers_total` | `LastValue` | The number of handlers that were re-used during config transition.
`mixer_handler_workers_total` | `LastValue` | The current number of active worker routines in a given adapter environment.
`mixer_runtime_dispatch_duration_seconds` | `Distribution` | Duration in seconds for adapter dispatches handled by Mixer.
`mixer_runtime_dispatches_total` | `Count` | Total number of adapter dispatches handled by Mixer.
`num_failed_outgoing_requests` | `Sum` | Number of failed outgoing requests (e.g. to a token exchange server, CA, etc.)
`num_outgoing_requests` | `Sum` | Number of total outgoing requests (e.g. to a token exchange server, CA, etc.)
`num_outgoing_retries` | `Sum` | Number of outgoing retry requests (e.g. to a token exchange server, CA, etc.)
`outgoing_latency` | `Sum` | The latency of outgoing requests (e.g. to a token exchange server, CA, etc.) in milliseconds.
`pilot_conflict_inbound_listener` | `LastValue` | Number of conflicting inbound listeners.
`pilot_conflict_outbound_listener_http_over_current_tcp` | `LastValue` | Number of conflicting wildcard http listeners with current wildcard tcp listener.
`pilot_conflict_outbound_listener_http_over_https` | `LastValue` | Number of conflicting HTTP listeners with well known HTTPS ports
`pilot_conflict_outbound_listener_tcp_over_current_http` | `LastValue` | Number of conflicting wildcard tcp listeners with current wildcard http listener.
`pilot_conflict_outbound_listener_tcp_over_current_tcp` | `LastValue` | Number of conflicting tcp listeners with current tcp listener.
`pilot_destrule_subsets` | `LastValue` | Duplicate subsets across destination rules for same host
`pilot_duplicate_envoy_clusters` | `LastValue` | Duplicate envoy clusters caused by service entries with same hostname
`pilot_eds_no_instances` | `LastValue` | Number of clusters without instances.
`pilot_endpoint_not_ready` | `LastValue` | Endpoint found in unready state.
`pilot_inbound_updates` | `Sum` | Total number of updates received by pilot.
`pilot_invalid_out_listeners` | `LastValue` | Number of invalid outbound listeners.
`pilot_jwks_resolver_network_fetch_fail_total` | `Sum` | Total number of failed network fetch by pilot jwks resolver
`pilot_jwks_resolver_network_fetch_success_total` | `Sum` | Total number of successfully network fetch by pilot jwks resolver
`pilot_k8s_cfg_events` | `Sum` | Events from k8s config.
`pilot_k8s_endpoints_with_no_pods` | `Sum` | Endpoints that does not have any corresponding pods.
`pilot_k8s_object_errors` | `LastValue` | Errors converting k8s CRDs
`pilot_k8s_reg_events` | `Sum` | Events from k8s registry.
`pilot_no_ip` | `LastValue` | Pods not found in the endpoint table, possibly invalid.
`pilot_proxy_convergence_time` | `Distribution` | Delay in seconds between config change and a proxy receiving all required configuration.
`pilot_proxy_queue_time` | `Distribution` | Time in seconds, a proxy is in the push queue before being dequeued.
`pilot_rds_expired_nonce` | `Sum` | Total number of RDS messages with an expired nonce.
`pilot_services` | `LastValue` | Total services known to pilot.
`pilot_total_rejected_configs` | `Sum` | Total number of configs that Pilot had to reject or ignore.
`pilot_total_xds_internal_errors` | `Sum` | Total number of internal XDS errors in pilot.
`pilot_total_xds_rejects` | `Sum` | Total number of XDS responses from pilot rejected by proxy.
`pilot_virt_services` | `LastValue` | Total virtual services known to pilot.
`pilot_vservice_dup_domain` | `LastValue` | Virtual services with dup domains.
`pilot_xds` | `LastValue` | Number of endpoints connected to this pilot using XDS.
`pilot_xds_cds_reject` | `LastValue` | Pilot rejected CDS configs.
`pilot_xds_eds_all_locality_endpoints` | `LastValue` | Network endpoints for each cluster(across all localities), as of last push. Zero endpoints is an error.
`pilot_xds_eds_instances` | `LastValue` | Instances for each cluster(grouped by locality), as of last push. Zero instances is an error.
`pilot_xds_eds_reject` | `LastValue` | Pilot rejected EDS.
`pilot_xds_lds_reject` | `LastValue` | Pilot rejected LDS.
`pilot_xds_push_context_errors` | `Sum` | Number of errors (timeouts) initiating push context.
`pilot_xds_push_time` | `Distribution` | Total time in seconds Pilot takes to push lds, rds, cds and eds.
`pilot_xds_pushes` | `Sum` | Pilot build and send errors for lds, rds, cds and eds.
`pilot_xds_rds_reject` | `LastValue` | Pilot rejected RDS.
`pilot_xds_write_timeout` | `Sum` | Pilot XDS response write timeouts.
`sidecar_injection_failure_total` | `Sum` | Total number of failed Side car injection requests.
`sidecar_injection_requests_total` | `Sum` | Total number of Side car injection requests.
`sidecar_injection_skip_total` | `Sum` | Total number of skipped injection requests.
`sidecar_injection_success_total` | `Sum` | Total number of successful Side car injection requests.
`total_active_connections` | `Sum` | The total number of active SDS connections.
`total_push_errors` | `Sum` | The total number of failed SDS pushes.
`total_pushes` | `Sum` | The total number of SDS pushes.
`total_secret_update_failures` | `Sum` | The total number of dynamic secret update failures reported by proxy.
`total_stale_connections` | `Sum` | The total number of stale SDS connections.